//+------------------------------------------------------------------+
//|                                                 Wilder's DMI.mq4 |
//|                                                  coded by mladen |
//|                                                                  |
//| Directional movement index was developed by Welles Wilder        |
//+------------------------------------------------------------------+
/*https://www.forex-tsd.com/forum/exclusive-forum/elite-section/3686-?q=adx
25-04-2015, 23:47
Re: Elite indicators 
 This is Wilders dmi with slope coloring on the adx and with a histo that is 
 measuring the diplus/diminus slope. Looks like it may be of some use, one 
 thing to remember(sure most of you know this already) is the slope of the 
 adx is only telling whether the market is trending or not, it is not telling 
 the direction, so when the adx is blue and if using the histo and it is 
 above zero will be in an uptrend, if adx is blue and if using the histo 
 and it's below zero will be in a downtrend. Not sure yet how to use the 
 diplus/diminus slope but maybe good for exits. The indicator has options 
 for alerts and arrows on diplus diminus cross and options to use the adx,
 adxr,diplus diminus histo, and or diplus dimus lines. 
*/


#property copyright "mladen"
#property link      "www.forex-tsd,com"

#property indicator_separate_window
#property  indicator_buffers 4
#property indicator_color1   clrLimeGreen
#property indicator_color2   clrLimeGreen
#property indicator_color3   clrPaleVioletRed
#property indicator_color4   clrPaleVioletRed
#property indicator_width1   2 
#property indicator_width3   2 
#property indicator_minimum  0
#property indicator_maximum  1

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame              = PERIOD_CURRENT;
extern int             DMILength              = 14;
extern int             SS_Period              = 5;
extern int             Level                  = 20;
extern bool            alertsOn               = false;
extern bool            alertsOnCurrent        = true;
extern bool            alertsMessage          = true;
extern bool            alertsSound            = false;
extern bool            alertsNotify           = false;
extern bool            alertsEmail            = false;
extern string          soundFile              = "alert2.wav";
extern bool            ShowArrows             = false;
extern string          arrowsIdentifier       = "DMI Arrows1";
extern double          arrowsUpperGap         = 1.0;
extern double          arrowsLowerGap         = 1.0;
extern color           arrowsUpColor          = clrLimeGreen;
extern color           arrowsDnColor          = clrRed;
extern int             arrowsUpCode           = 241;
extern int             arrowsDnCode           = 242;
extern bool            verticalLinesVisible   = false;                // Show vertical lines
extern bool            linesOnFirst           = false;                // lines on first mtf bar or not
extern string          verticalLinesID        = "dmi Lines1";         // Vertical lines unique ID
extern color           verticalLinesUpColor   = clrDeepSkyBlue;       // Color for down cross
extern color           verticalLinesDownColor = clrSandyBrown;        // Color for up cross
extern ENUM_LINE_STYLE verticalLinesStyle     = STYLE_DOT;            // Lines style
extern int             verticalLinesWidth     = 0;                    // Lines width
extern bool            Interpolate            = true;

//
//
//
//
//

double DIp[];
double DIm[];
double ADX[];
double adxDa[];
double adxDb[];
double ADXR[];
double ADXLevel[];
double dihup[];
double dihum[];
double dihdp[];
double dihdm[];
double trend[];
double slope[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(13);
   SetIndexBuffer(0, dihup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, dihdp); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, dihdm); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, dihum); SetIndexStyle(3,DRAW_HISTOGRAM);   
   SetIndexBuffer(4, DIp);      
   SetIndexBuffer(5, DIm);      
   SetIndexBuffer(6, ADX);  
   SetIndexBuffer(7, adxDa); 
   SetIndexBuffer(8, adxDb);    
   SetIndexBuffer(9, ADXR);     
   SetIndexBuffer(10,ADXLevel); SetIndexLabel(10,NULL);
   SetIndexBuffer(11,trend);
   SetIndexBuffer(12,slope);
      for (int i=4;i<13;i++) SetIndexEmptyValue(i,0.00);
      
   //
   //
   //
   //
   //

      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);


   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(TimeFrame)+" Wilder's_DMI + hist mtf( D-"+DMILength+")"); // (A-"+ADXLength+")");
   return(0);
}

int deinit() 
{  
   deleteArrows(); 
   string lookFor       = verticalLinesID+":";
   int lookForLength = StringLen(lookFor);
      for (int i=ObjectsTotal()-1; i>=0; i--)
      {
         string name = ObjectName(i);
         if (StringSubstr(name,0,lookForLength) == lookFor) ObjectDelete(name);
      }
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][3];
#define _DIp 0
#define _DIm 1
#define _TR  2

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-2);
           if (returnBars)  { dihup[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
      if (slope[limit]==-1) CleanPoint(limit,adxDa,adxDb);
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      double sf = (DMILength-1.0)/DMILength;
      for (i=limit, r=Bars-i-1;i>=0;i--,r++)
      {
         double currTR  = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
         double DeltaHi = High[i] - High[i+1];
	      double DeltaLo = Low[i+1] - Low[i];
         double plusDM  = 0.00;
         double minusDM = 0.00;
         
            if ((DeltaHi > DeltaLo) && (DeltaHi > 0)) plusDM  = DeltaHi;
            if ((DeltaLo > DeltaHi) && (DeltaLo > 0)) minusDM = DeltaLo;      
         
         //
         //
         //
         //
         //
         
            work[r][_DIp] = sf*work[r-1][_DIp] + plusDM;
            work[r][_DIm] = sf*work[r-1][_DIm] + minusDM;
            work[r][_TR]  = sf*work[r-1][_TR]  + currTR;
            ADXLevel[i]   = Level;

         //
         //
         //
         //
         //
                  
            DIp[i]   = 0.00;                   
            DIm[i]   = 0.00;                   
            dihup[i] = EMPTY_VALUE;
            dihdp[i] = EMPTY_VALUE;
            dihdm[i] = EMPTY_VALUE;
            dihum[i] = EMPTY_VALUE;
            if (work[r][_TR] > 0)
               {              
                  DIp[i] = 100.00 * iSsm(work[r][_DIp]/work[r][_TR],SS_Period,i,0);
                  DIm[i] = 100.00 * iSsm(work[r][_DIm]/work[r][_TR],SS_Period,i,1);
               }            
               if (DIp[i]>DIm[i] && DIp[i]>DIp[i+1]) dihup[i] = 1;
               if (DIp[i]>DIm[i] && DIp[i]<DIp[i+1]) dihdp[i] = 1;
               if (DIp[i]<DIm[i] && DIm[i]>DIm[i+1]) dihdm[i] = 1;
               if (DIp[i]<DIm[i] && DIm[i]<DIm[i+1]) dihum[i] = 1;
               
                  double DX;
                  if((DIp[i] + DIm[i])>0) 
                       DX = 100*MathAbs(iSsm((DIp[i] - DIm[i])/(DIp[i] + DIm[i]),SS_Period,i,2)); 
                  else DX = iSsm(0.00                                           ,SS_Period,i,2);
                  ADX[i]  = sf*ADX[i+1] + DX/DMILength; 
                  ADXR[i] = 0.5*(ADX[i] + ADX[i+DMILength]);
               
               //
               //
               //
               //
               //
               
               adxDa[i] = 0.00;
               adxDb[i] = 0.00;
               slope[i] = slope[i+1];
               trend[i] = trend[i+1];
                  if (ADX[i]>ADX[i+1]) slope[i] = 1;
                  if (ADX[i]<ADX[i+1]) slope[i] =-1;
                  if (DIp[i]>DIm[i])   trend[i] = 1;
                  if (DIp[i]<DIm[i])   trend[i] =-1;
               
                  //
                  //
                  //
                  //
                  //
     
                  if (ShowArrows)
                  {
                    deleteArrow(Time[i]);
                    if (trend[i] != trend[i+1])
                    {
                      if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                      if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
                    }
                  }
                  manageLines(i);
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1; 
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("crossed up");
         else  doAlert("crossed down");       
   }        
      
      
   return(0);      
   }
      
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (slope[limit]==-1) CleanPoint(limit,adxDa,adxDb);
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ADXLevel[i] = Level;
         dihup[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMILength,SS_Period,Level,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDownColor,verticalLinesStyle,verticalLinesWidth,0, y);
         dihdp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMILength,SS_Period,Level,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDownColor,verticalLinesStyle,verticalLinesWidth,1, y);
         dihdm[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMILength,SS_Period,Level,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDownColor,verticalLinesStyle,verticalLinesWidth,2, y);
         dihum[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMILength,SS_Period,Level,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDownColor,verticalLinesStyle,verticalLinesWidth,3, y);
         DIp[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMILength,SS_Period,Level,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDownColor,verticalLinesStyle,verticalLinesWidth,4, y);
         DIm[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMILength,SS_Period,Level,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDownColor,verticalLinesStyle,verticalLinesWidth,5, y);
         ADX[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMILength,SS_Period,Level,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDownColor,verticalLinesStyle,verticalLinesWidth,6, y);
         adxDa[i] = 0.00;
         adxDb[i] = 0.00;
         ADXR[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMILength,SS_Period,Level,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDownColor,verticalLinesStyle,verticalLinesWidth,9, y);
         slope[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,DMILength,SS_Period,Level,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,verticalLinesVisible,linesOnFirst,verticalLinesID,verticalLinesUpColor,verticalLinesDownColor,verticalLinesStyle,verticalLinesWidth,12,y);
         
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               DIp[i+k]  = DIp[i]  + (DIp[i+n] - DIp[i]) *k/n;
               DIm[i+k]  = DIm[i]  + (DIm[i+n] - DIm[i]) *k/n;
               ADX[i+k]  = ADX[i]  + (ADX[i+n] - ADX[i]) *k/n;
               ADXR[i+k] = ADXR[i] + (ADXR[i+n]- ADXR[i])*k/n;
               if (dihup[i]!= 0.00) dihup[i+k] = DIp[i+k]-DIm[i+k];
               if (dihdp[i]!= 0.00) dihdp[i+k] = DIp[i+k]-DIm[i+k];
               if (dihdm[i]!= 0.00) dihdm[i+k] = DIp[i+k]-DIm[i+k];
               if (dihum[i]!= 0.00) dihum[i+k] = DIp[i+k]-DIm[i+k];
            }
         
   } 
   for (i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,adxDa,adxDb,ADX);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSsm[][6];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != 0.00) && (second[i+1] != 0.00))
        second[i+1] = 0.00;
   else
      if ((first[i] != 0.00) && (first[i+1] != 0.00) && (first[i+2] == 0.00))
          first[i+1] = 0.00;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == 0.00)
      {
         if (first[i+2] == 0.00) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = 0.00;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = 0.00;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = 0.00;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Wilders DMI ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Wilders DMI "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageLines(int i)
{
   if (verticalLinesVisible && (i+1)<Bars)
   {
         ObjectDelete(verticalLinesID+":"+(string)Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i] == 1) drawLine(i,verticalLinesUpColor);
            if (trend[i] ==-1) drawLine(i,verticalLinesDownColor);
         }
   }
}               

void drawLine(int i,color theColor)
{
   string name = verticalLinesID+":"+(string)Time[i];
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!linesOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_VLINE,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}




